/*      sample.h

        AXP-SI21/SI22 Tv
        Copyright (c) 1999  ADTEK SYSTEM SCIENCE Co., Ltd.

        AXP-SI2x  CH1  CH2 NX P[uŐڑA
        CH1 瑗M CH2 ŎM܂B

        Visual C++ 1.5
                cl sample.c
        Borland C++ 5.0
                bcc sample.c
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <dos.h>

#include "axpsi2x.h"

/*//////////////////////////////////////////////////////////////////////
*/

#if     defined( __TURBOC__ )
#define _outp   outportb
#define _inp    inportb
#endif

/*//////////////////////////////////////////////////////////////////////
*/

#ifndef FALSE
#define FALSE   0
#endif

#ifndef TRUE
#define TRUE    ( ! FALSE )
#endif

#define SOCKET  0

#define RBR     0
#define THR     0
#define DLL     0
#define IER     1
#define DLM     1
#define IIR     2
#define FCR     2
#define LCR     3
#define MCR     4
#define LSR     5
#define MSR     6
#define SCR     7
#define B9600   12
#define B115K   1
#define MODE    0x1f            /* data:8bit parity:even stop:2 */

#define M8259C  0x20            /* 8259 master control register */
#define M8259D  0x21            /* 8259 master data register */
#define S8259C  0xa0            /* 8259 slave control register */
#define S8259D  0xa1            /* 8259 slave data register */

#define EOI     0x20            /* End Of Interrupt */

#define IRQM0   ( 1 << 0 )      /* 8253 */
#define IRQM1   ( 1 << 1 )      /* KBD */
#define IRQM2   ( 1 << 2 )      /* 8259 slave */
#define IRQM3   ( 1 << 3 )      /* COM2 */
#define IRQM4   ( 1 << 4 )      /* COM1 */
#define IRQM5   ( 1 << 5 )      /* (LPT2) */
#define IRQM6   ( 1 << 6 )      /* FD */
#define IRQM7   ( 1 << 7 )      /* LPT1 */
#define IRQM8   ( 1 << 0 )      /* RTC */
#define IRQM9   ( 1 << 1 )      /* Redirected IRQ2 */
#define IRQM10  ( 1 << 2 )      /* */
#define IRQM11  ( 1 << 3 )      /* */
#define IRQM12  ( 1 << 4 )      /* Mouse */
#define IRQM13  ( 1 << 5 )      /* Math */
#define IRQM14  ( 1 << 6 )      /* HD */
#define IRQM15  ( 1 << 7 )      /* HD2 */

#define IRQV0   0x08            /* 8253 */
#define IRQV1   0x09            /* KBD */
#define IRQV2   0x0a            /* 8259 slave */
#define IRQV3   0x0b            /* COM2 */
#define IRQV4   0x0c            /* COM1 */
#define IRQV5   0x0d            /* (LPT2) */
#define IRQV6   0x0e            /* FD */
#define IRQV7   0x0f            /* LPT1 */
#define IRQV8   0x70            /* RTC */
#define IRQV9   0x71            /* Redirected IRQ2 */
#define IRQV10  0x72            /* */
#define IRQV11  0x73            /* */
#define IRQV12  0x74            /* Mouse */
#define IRQV13  0x75            /* Math */
#define IRQV14  0x76            /* HD */
#define IRQV15  0x77            /* HD2 */

enum    _INTERRUPT_STATUS
{
        QS_NONE,
        QS_BREAK,
        QS_FRAMING,
        QS_PARITY,
        QS_OVERRUN,
        QS_RECEIVE
};

/*//////////////////////////////////////////////////////////////////////
*/

#ifdef  __cplusplus
extern  "C"
{
#endif

typedef struct  _IRQI           /* IRQԍAPIC}XNAxN^̊֌W */
{
        unsigned char   n;              /* IRQ# */
        unsigned char   m;              /* Mask */
        unsigned char   v;              /* Vector# */
}       IRQI;

typedef struct  _RING           /* Mobt@ */
{
        int     flag;
        unsigned int    rcnt;
        unsigned int    wcnt;
        unsigned char   dat[ 256 ];
        unsigned short  com;
}       RING;

#ifdef  __cplusplus
}
#endif

/*//////////////////////////////////////////////////////////////////////
*/

unsigned short  Trans;
unsigned short  Receive;
int     IrqVect;
int     IrqMask;
RING    Rx;

/*//////////////////////////////////////////////////////////////////////
*/

int     si2x_get_res    ( SI2XRES *pres );
IRQI *  find_irqi       ( int irqn );
void    com_init        ( unsigned short com );
void    com_trans       ( unsigned short com, char ch );
int     com_receive     ( char* dat );
void    vec_set         ( void );
void    vec_restore     ( void );
void    _interrupt _far rx_int  ( void );
void    ( _interrupt _far *oldfunc )();

/*//////////////////////////////////////////////////////////////////////
  Gg |Cg
*/

int     main( void )
{
static  char    str[] = "0123456789abcdefghijklmnopqrrstuvwxyz";
        SI2XRES res;
        IRQI *  pirqi;
        char    dat;
        unsigned int    i;
        unsigned int    j;

        res.wSocket = SOCKET;
        switch ( si2x_get_res( &res ) )
        {
        default:
                printf( "AXP-SI2x driver not loaded\n" );
                return 1;
        case SI2X_E_SUCCESS:
                break;
        case SI2X_E_BAD_SOCKET:
                printf( "Bad wSocket\n" );
                return 1;
        case SI2X_E_NO_CARD:
                printf( "No card\n" );
                return 1;
        case SI2X_E_NOT_CONFIGURATED:
                printf( "Not a AXP-SI2x\n" );
                return 1;
        }

        printf( "IO0:%04X IO1:%04X IRQ:%u\n",
                        res.wIOBase0, res.wIOBase1, res.iIRQ );

        if ( NULL == ( pirqi = find_irqi( res.iIRQ ) ) )
        {
                printf( "Unsupported IRQ#\n" );
                return 1;
        }

        Trans = res.wIOBase0;
        Receive = res.wIOBase1;
        IrqMask = pirqi->m;
        IrqVect = pirqi->v;
        Rx.com = Receive;
        Rx.flag = QS_NONE;
        Rx.rcnt = Rx.wcnt = 0;

        com_init( Receive );
        vec_set();
        com_init( Trans );

        for ( i=0 ; i<strlen( str ) ; i++ )
        {
                com_trans( Trans, str[ i ] );
        }

        for ( i=0 ; i<6000 ; i++ )
        {
                ;               /* wait */
        }

        for ( i=0 ; i<strlen( str ) ; i++ )
        {
                for ( j=6000 ;; j-- )
                {
                        if ( com_receive( &dat ) == TRUE )
                        {
                                break;
                        }

                        if ( j == 0 )
                        {
                                puts( "Receive Time out Error!!" );
                                goto end;
                        }
                }
                if ( dat != str[ i ] )
                {
                        printf( "data Error!!" );
                        goto end;
                }
                printf( "%c", dat );
        }
end:
        vec_restore();

        return 0;
}

/*//////////////////////////////////////////////////////////////////////
  \[X擾
*/

int     si2x_get_res( SI2XRES *pres )
{
        union   REGS    regs;
        struct  SREGS   sregs;
        int     iHandle;

        if ( _dos_open( SZ_AXPSI2X, 0, &iHandle ) )
        {
                return -1;
        }

        pres->wActRes = SI2X_ACT_INQ_RESOURCE;
        regs.x.ax = 0x4402;
        regs.x.bx = iHandle;
        regs.x.cx = sizeof ( *pres );
        regs.x.dx = ( unsigned short ) pres;
        sregs.ds = ( unsigned short )
                        ( ( unsigned long ) ( void _far * ) pres >> 16 );
        ( void ) intdosx( &regs, &regs, &sregs );
        ( void ) _dos_close( iHandle );
        if ( regs.x.cflag )
        {
                return -1;
        }

        return pres->wActRes;
}

/*//////////////////////////////////////////////////////////////////////
  IRQ ԍ PIC ̃}XNуxN^ԍ߂
*/

IRQI *  find_irqi( int irqn )
{
static  IRQI    airqi[] =
        {
                {   3, IRQM3,  IRQV3 },
                {   4, IRQM4,  IRQV4 },
                {   5, IRQM5,  IRQV5 },
                {   7, IRQM7,  IRQV7 },
                { 255,     0,      0 }
        };
        IRQI *  p;

        for ( p = airqi; 15 >= p->n; p++ )
        {
                if ( p->n == irqn )
                {
                        return p;
                }
        }

        return NULL;
}

/*//////////////////////////////////////////////////////////////////////
  |[g
*/

void    com_init( unsigned short com )
{
        _outp( com + MCR, 0x00 );
        _outp( com + LCR, 0x80 );       /* DLAB=1 */
        _outp( com + DLL, B9600 );      /* baudrate 9600 bps */
        _outp( com + DLM, 0 );
        _outp( com + LCR, MODE );       /* D8 PE S2 */
        _outp( com + IER, 0x01 );       /* receive interrupt enable */
        _outp( com + MCR, 0x0b );       /* RTS, DTR active */
        if ( _inp( com + LSR ) & 0x01 )
        {
                ( void ) _inp( com + RBR );     /* dump */
        }
}

/*//////////////////////////////////////////////////////////////////////
  PM
*/

void    com_trans( unsigned short com, char ch )
{
        unsigned short  cnt     = 0xffff;

        while ( ( _inp( com + LSR ) & 0x20 ) == 0 )
        {
                if ( cnt-- == 0 )
                {
                        puts( "Transmitter Holding Register Error!!" );
                        exit( 1 );
                }
        }
        _outp( com + THR, ch );
}

/*//////////////////////////////////////////////////////////////////////
  PM
*/

int     com_receive( char* dat )
{
        int     res     = FALSE;

        switch ( Rx.flag )
        {
        case QS_NONE:
                break;
        case QS_RECEIVE:
                if ( Rx.wcnt != Rx.rcnt )
                {
                        *dat=Rx.dat[ Rx.rcnt++ ];
                        res=TRUE;
                }
                break;
        case QS_BREAK:
                puts( "Break Error!!" );
                vec_restore();
                exit( 1 );
        case QS_FRAMING:
                puts( "Framing Error!!" );
                vec_restore();
                exit( 1 );
        case QS_PARITY:
                puts( "Parity Error!!" );
                vec_restore();
                exit( 1 );
        case QS_OVERRUN:
                puts( "Over run Error!!" );
                vec_restore();
                exit( 1 );
        }
        return res;
}

/*//////////////////////////////////////////////////////////////////////
  荞݃nhݒ
*/

void    vec_set( void )
{
        if ( oldfunc != NULL )
        {
                return;
        }

        oldfunc = _dos_getvect( IrqVect );
        _dos_setvect( IrqVect, rx_int );
        _disable();
        _outp( M8259D, ( _inp( M8259D ) & ~IrqMask ) );
        _enable();
}

/*//////////////////////////////////////////////////////////////////////
  荞݃nhA
*/

void    vec_restore( void )
{
        if ( NULL == oldfunc )
        {
                return;
        }

        _dos_setvect( IrqVect, oldfunc );
        oldfunc = NULL;
        _disable();
        _outp( M8259D, ( _inp( M8259D ) | IrqMask ) );
        _enable();
}

/*//////////////////////////////////////////////////////////////////////
  M荞݃nh
*/

void    _interrupt _far rx_int( void )
{
        unsigned char   tmp;

        _disable();
        switch ( 0x0f & _inp( Rx.com + IIR ) )
        {
        case 0x1:
                break;
        case 0x4:
                tmp = ( unsigned char ) _inp( Rx.com + LSR );
                if ( ( tmp & 0x10 ) != 0 )
                {
                        Rx.flag = QS_BREAK;
                }
                else if ( ( tmp & 0x08 ) != 0 )
                {
                        Rx.flag = QS_FRAMING;
                }
                else if ( ( tmp & 0x04 ) != 0 )
                {
                        Rx.flag = QS_PARITY;
                }
                else if ( ( tmp & 0x02 ) != 0 )
                {
                        Rx.flag = QS_OVERRUN;
                }
                else if ( ( tmp & 0x01 ) && ( ( Rx.flag == QS_NONE ) || ( Rx.flag == QS_RECEIVE ) ) )
                {
                        if ( 255 <= Rx.wcnt )
                        {
                                tmp = 0;
                        }
                        else
                        {
                                tmp = ( unsigned char ) ( 1 + Rx.wcnt );
                        }

                        if ( tmp != Rx.rcnt )
                        {
                                Rx.dat[ Rx.wcnt++ ] = ( char )_inp( Rx.com + RBR );
                                Rx.flag = QS_RECEIVE;
                        }
                        else
                        {
                                _inp( Rx.com + RBR );
                        }
                }
                break;
        }
        _outp( M8259C, EOI );
        _enable();
}
